]> git.pld-linux.org Git - packages/rpm.git/blame - rpm.macros
- typo
[packages/rpm.git] / rpm.macros
CommitLineData
b52fc1f1 1# $Revision$, $Date$
cc2b296f 2# PLD Linux rpm macros
a8bf9720 3
90c0eaed 4%epoch 0
31b569b6 5%x8664 x86_64 amd64 ia32e
cd33aab7 6
a544555d 7# kernel compiler
6f86c45e 8%kgcc %{__cc}
cabacfeb 9%kgcc_package gcc
a544555d 10
4343a1f7
ER
11%__rm /bin/rm --interactive=never
12
5f9f9bd7 13# Build system path macros.
14#
8af1c6f5
JB
15%__autoconf autoconf %{?debug:-Wall}
16%__automake automake -a -c -f --foreign
429d047e 17%__autopoint autopoint --force
18
aad1c8e4 19%__gettextize { \
4cd84746 20 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
31b569b6 21 gettextize --copy --force --no-changelog; \
93bce43f 22 else \
31b569b6 23 gettextize --copy --force --no-changelog --intl; \
4cd84746
JB
24 fi; \
25 if [ ! -f po/Makevars ]; then \
31b569b6 26 cp -f po/Makevars{.template,}; \
4cd84746 27 fi; \
4cd84746 28}
429d047e 29
30%__glib_gettextize glib-gettextize --copy --force
31%__gnome_doc_common gnome-doc-common --copy
db1adf13 32%__gnome_doc_prepare gnome-doc-prepare --copy --force
429d047e 33%__gtkdocize gtkdocize --copy
34%__intltoolize intltoolize --copy --force
35%__libtoolize libtoolize --copy --force
5f9f9bd7 36
702e8027
ER
37# Path to top of build area.
38%_topdir %(test -d ../SPECS && (cd ..; pwd) || echo $HOME/rpm)
39
38e780ca
ER
40# The number of cvs changelog entries kept when building package.
41%_buildchangelogtruncate 20
42
bd1cd543 43%dependencytracking %{nil}
31b569b6 44
073ae3ba
ER
45# Relations between package names that cause dependency loops
46# with legacy packages that cannot be fixed. Relations are
47# specified as
48# p>q
49# where package p has a Requires: on something that package q Provides:
50#
51# XXX Note: that there cannot be any whitespace within the string "p>q",
52# and that both p and q are package names (i.e. no version/release).
53%_dependency_whiteout %{nil}
54
9ba56d1b
AM
55%_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
56 && RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"; \\\
57 [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$RPM_BUILD_NCPUS")
cece03f9 58
59#-----------------------------------------------------------------
60#
61# (re)definition of %{rpm*flags} with %filterout_* support
7c9f98ce
ER
62# BuildRequires: awk
63# BuildRequires: rpmbuild(macros) >= 1.315
cece03f9 64#
65# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
a0bf497e 66# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
67# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
68# %rpmldflags = %optldflags - %filterout_ld
cece03f9 69#
70# Regular expressions are supported, but to avoid some character be treated
71# as regular expression it must be escaped twice.
72
73%filter_out \
bf66145e 74 for (i = 1; i in I; i++) { A=0; \
cece03f9 75 for (f in F) { \
76 if (I[i] ~ "^" F[f] "$") A=1; \
77 }; \
78 if (!A) printf(I[i] FS); \
79 }
80
81%rpmcflags %(awk 'BEGIN {
82 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
a0bf497e 83 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
cece03f9 84 %{filter_out}
85}')
86
87%rpmcxxflags %(awk 'BEGIN {
a0bf497e 88 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
89 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
cece03f9 90 %{filter_out}
91}')
92
93%rpmldflags %(awk 'BEGIN {
b699ccff 94 split("%{?optldflags}",I);
cece03f9 95 split("%{?filterout_ld}",F)
96 %{filter_out}
97}')
98
111942c6 99# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
100# but, don't use it, better use gcc as linker
101%ld_rpmldflags %(awk 'BEGIN {
102 split("%{rpmldflags}",F);
103 for (f in F) {
104 s = F[f];
105 if (s ~ /^-Wl,/) {
106 s = substr(s,5);
107 gsub(/,/," ",s);
108 };
109 printf(s FS);
110 };
111}')
112
cd33aab7 113#-----------------------------------------------------------------
9f0287b5 114%configure2_13 { \
cd33aab7
AM
115 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
116 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
117 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
af18d245 118 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
cd33aab7 119 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
d4392e78 120 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
c55f2219 121 CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
4eac2e49
AM
122 %{?__cc:CC="%{__cc}" ; export CC ; } \
123 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
5b0f0ac9 124 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
fa74a11c 125 --host=%{_target_platform} \
cd33aab7
AM
126 --prefix=%{_prefix} \
127 --exec-prefix=%{_exec_prefix} \
128 --bindir=%{_bindir} \
129 --sbindir=%{_sbindir} \
130 --sysconfdir=%{_sysconfdir} \
131 --datadir=%{_datadir} \
132 --includedir=%{_includedir} \
133 --libdir=%{_libdir} \
134 --libexecdir=%{_libexecdir} \
135 --localstatedir=%{_localstatedir} \
136 --sharedstatedir=%{_sharedstatedir} \
137 --mandir=%{_mandir} \
138 --infodir=%{_infodir} \
c3420100 139 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
8b4be1e1 140 %{dependencytracking} \
cd33aab7
AM
141}
142
53c34296
ER
143# override __cmake to add -j4 in your ~/.rpmmacros for parallel make
144%__cmake /usr/bin/cmake
29771119
ER
145%cmake { \
146CC="%{__cc}" \
147CXX="%{__cxx}" \
148CFLAGS="%{rpmcflags}" \
149CXXFLAGS="%{rpmcxxflags}" \
53c34296
ER
150%{__cmake} \
151}
152
153# override __scons to add -j4 in your ~/.rpmmacros for parallel make
154%__scons /usr/bin/scons
155%scons { \
156%{__scons} \
13eb0f84
ER
157 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
158 CFLAGS="${CFLAGS:-%rpmcflags}" \
159 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
160 FFLAGS="${FFLAGS:-%rpmcflags}" \
161 CPPFLAGS="${CPPFLAGS:-}" \
162 %{?__cc:CC="%{__cc}"} \
163 %{?__cxx:CXX="%{__cxx}"} \
164 libsuffix=%{_lib} \
165 prefix=%{_prefix} \
29771119
ER
166}
167
ac093701 168# waf. see waf.spec
53c34296 169# override __waf to add -j4 in your ~/.rpmmacros for parallel make
ac093701
ER
170%__waf /usr/bin/waf
171%waf { \
ac093701
ER
172CC="%{__cc}" \
173CXX="%{__cxx}" \
1624498d 174CPP="%{__cpp}" \
ac093701
ER
175CFLAGS="%{rpmcflags}" \
176CXXFLAGS="%{rpmcxxflags}" \
177%{__waf} \
ac093701
ER
178}
179
85f82bec 180#----------------------------------------------------------------
b7626f51 181#%configure_cache 0
43f81f06 182%configure_cache_file %{buildroot}.configure.cache
7e4e3f2b 183
b8cf6778 184%configure {./configure \
85f82bec
AF
185 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
186 CFLAGS="${CFLAGS:-%rpmcflags}" \
af18d245 187 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
85f82bec 188 FFLAGS="${FFLAGS:-%rpmcflags}" \
d4392e78 189 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
418d9760 190 CPPFLAGS="${CPPFLAGS:-}" \
4eac2e49
AM
191 %{?__cc:CC="%{__cc}"} \
192 %{?__cxx:CXX="%{__cxx}"} \
a9bea0f7 193 --host=%{_target_platform} \
85f82bec
AF
194 --build=%{_target_platform} \
195 --prefix=%{_prefix} \
196 --exec-prefix=%{_exec_prefix} \
197 --bindir=%{_bindir} \
198 --sbindir=%{_sbindir} \
199 --sysconfdir=%{_sysconfdir} \
200 --datadir=%{_datadir} \
201 --includedir=%{_includedir} \
202 --libdir=%{_libdir} \
203 --libexecdir=%{_libexecdir} \
204 --localstatedir=%{_localstatedir} \
205 --sharedstatedir=%{_sharedstatedir} \
206 --mandir=%{_mandir} \
207 --infodir=%{_infodir} \
c3420100 208 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
8b4be1e1 209 %{dependencytracking} \
b7626f51 210 %{?configure_cache:--cache-file=%{configure_cache_file}} \
85f82bec
AF
211}
212
9cd5fb46
ER
213# overload to insert debuginfo package
214%prep \
215%if 0%{?_enable_debug_packages}\
216%{debug_package}\
217%endif\
218%%prep\
219%{nil}
220
cd33aab7
AM
221# Location of autoconf macros
222%_aclocaldir %(aclocal --print-ac-dir)
223
32720a50
AM
224# Location of omf files
225%_omf_dest_dir %(scrollkeeper-config --omfdir)
226
c5eece2c 227# Location of pkgconfig files
a46897a7 228%_pkgconfigdir /usr/%{_lib}/pkgconfig
c5eece2c 229
c917274d 230# Location of desktop files
231%_desktopdir /usr/share/applications
510f694c 232%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
c917274d 233
fb08fb4a 234# Location of pixmaps for applnk/desktop files
3a9bb008 235%_pixmapsdir /usr/share/pixmaps
cd33aab7 236
fb08fb4a 237# Location of themable icons for applnk/desktop files
986c3bcd 238%_iconsdir /usr/share/icons
239
c5eece2c
JB
240# Location of fonts directories
241%_fontsdir /usr/share/fonts
242
5cfcbc9e 243# Location of Gtk and associated libraries documentation
43f81f06 244%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
5cfcbc9e 245
eee08b2d 246# Location of KDE documentation
43f81f06 247%_kdedocdir %{_defaultdocdir}/kde/HTML
eee08b2d 248
a7cad6ae 249# unsermake script
250%__unsermake /usr/share/unsermake/unsermake
251
cd33aab7
AM
252# Current date
253%date %(LC_ALL="C" date +"%a %b %d %Y")
254
af65e87c
ER
255# tmp directory
256%tmpdir %(echo "${TMPDIR:-/tmp}")
257
cd33aab7
AM
258# Example files, programs, scripts...
259%_examplesdir /usr/src/examples
260
7127e0fc 261# Alternative kernel type/version
c604d0a9 262%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
7127e0fc 263
bd63739a 264# The directory holding Linux kernel sources
c604d0a9 265%_kernelsrcdir /usr/src/linux%{_alt_kernel}
bd63739a 266
cd33aab7 267# If non-empty "debug" macro defined, add "dbg" suffix to release number
5b0f0ac9 268%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
cd33aab7 269
5b0f0ac9 270# Requires name = version-release
48c1bf9f 271%requires_releq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}-%{R}\\n' | grep -v 'is not')
511ee4c6 272
48c1bf9f
ER
273%releq_kernel() %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})
274%releq_kernel_up() %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})
275%releq_kernel_smp() %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})
d606f9ca
ER
276%requires_releq_kernel(s:) Requires%{-s:(%{-s*})}: %releq_kernel
277%requires_releq_kernel_up(s:) Requires%{-s:(%{-s*})}: %releq_kernel_up
278%requires_releq_kernel_smp(s:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
511ee4c6 279
48c1bf9f
ER
280# XXX: why epoch 0 is stripped?
281%requires_eq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}\\n' | sed -e 's/ 0:/ /' | grep -v 'is not')
282%requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}' %2 | grep -v "is not")
e478b9e7 283
4ca2266c 284%apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
8dea1306 285
286# kernel version-release handling
1b00eeba 287%__kernel_ver %( VER_H=%{_kernelsrcdir}/include/linux/utsrelease.h; [ -f $VER_H ] || VER_H=%{_kernelsrcdir}/include/linux/version.h; [ -f $VER_H ] && (grep UTS_RELEASE $VER_H 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
48c1bf9f
ER
288%__kernel_rel %(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not")
289%__kernel_rpmvr %(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not")
31b569b6 290%_kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
066309eb 291%_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
fd4d8ee0 292
c2c27a5a 293# sgml macros
31b569b6
ER
294%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
295%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
296%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
297%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
298%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
299%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
c2c27a5a 300%docbook_sgmlcat_fix() { for l in \
301'' \
302' -- default decl --' \
303'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
304' -- hacks for opensp --' \
305'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
306'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
307'' \
308; do echo $l; done >> %1 \
309}
310
31bd34a8
ER
311# vim - "
312
f3f40db8
ER
313# minimum file size needed for compressed documents.
314# just smaller files than this get larger when compressed.
cdbfc157
ER
315# some stats:
316# - 0 byte file compressed was 25 bytes .gz
317# - 39 byte file was compressed as 57
318# - with test/test.spec@man 158 byte file was compressed also 158
319%_min_compress_bytes 159
f3f40db8 320
cd33aab7
AM
321#-----------------------------------------------------------------
322# find and gzip all files in %{_mandir} and %{infodir}
323#
324# Requires: xargs, find
325#
326#%no_install_post_compress_docs 1
327%__spec_install_post_compress_docs { \
f67bd19e 328%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
026ed59b 329 for i in /usr/share/man /usr/X11R6/man; do \
cd33aab7 330 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
026ed59b 331 echo "Compress man pages: $i"; \
f3f40db8
ER
332 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
333 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
38e531f0
ER
334 find $RPM_BUILD_ROOT$i -type l | while read a; do \
335 m=$(readlink $a); \
336 rm -f $a; \
337 echo .so ${m##*/} > $a; \
338 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
339 done; \
f3f40db8 340 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
cd33aab7
AM
341 fi; \
342 done; \
91bfff1c
JB
343 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
344 echo "Compress info pages: %{_infodir}"; \
345 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
346 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
347 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
026ed59b 348 fi; \
f67bd19e 349}; __spec_install_post_compress_docs } }
cd33aab7
AM
350
351#-----------------------------------------------------------------
352# Strip executable binaries and shared object files
353#
354# Requires: find, awk, strip, cut, xargs
355#
ee170415
JB
356# Special macros which affect this process:
357#%no_install_post_strip 1 # disable stripping at all
358#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
359#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
360#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
361#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
362#
cd33aab7 363%__spec_install_post_strip {%{!?debug: \
f67bd19e 364%{!?no_install_post_strip:__spec_install_post_strip() { \
65e03cc0 365if [ -d "$RPM_BUILD_ROOT" ]; then \
31bd34a8
ER
366 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
367 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
fefadad0
ER
368 if [ "$modulelist" ]; then \
369 modulecount=$(echo "$modulelist" | wc -l); \
7f1d3873 370 printf "Stripping %d kernel modules..." $modulecount; \
6cf69412
ER
371 echo "$modulelist" | xargs -l512 chmod u+w; \
372 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
373 echo "DONE"; \
374 fi; \
31bd34a8 375 fi; \
559c4907 376 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
d65f5d0e
JB
377 if [ -n "$filelist" ]; then \
378 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
379 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
380 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
ee170415 381 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
d65f5d0e 382 if [ -n "$elfexelist" ]; then \
fefadad0 383 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
d65f5d0e
JB
384 chmod u+w $elfexelist; \
385 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
386 echo "DONE"; \
387 fi; \
388 if [ -n "$elfsharedlist" ]; then \
fefadad0 389 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
d65f5d0e
JB
390 chmod u+w $elfsharedlist; \
391 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
392 echo "DONE"; \
393 fi; \
394 if [ -n "$archiveslist" ]; then \
fefadad0 395 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
d65f5d0e
JB
396 chmod u+w $archiveslist; \
397 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
398 echo "DONE"; \
399 fi; \
65e03cc0 400 fi; \
559c4907
ER
401 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
402 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
403 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
d65f5d0e 404 if [ -n "$filelist_all" ]; then \
fefadad0 405 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
ee170415 406 chmod u+w $filelist_all; \
d65f5d0e 407 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
fc87add2 408 echo "DONE"; \
cd33aab7 409 fi; \
d65f5d0e 410 if [ -n "$filelist_unneeded" ]; then \
fefadad0 411 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
ee170415 412 chmod u+w $filelist_unneeded; \
d65f5d0e 413 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
fc87add2 414 echo "DONE"; \
5b0f0ac9 415 fi; \
d65f5d0e 416 if [ -n "$filelist_debug" ]; then \
fefadad0 417 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
ee170415 418 chmod u+w $filelist_debug; \
d65f5d0e 419 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
fc87add2 420 echo "DONE"; \
f80cefa3 421 fi; \
f67bd19e 422fi; }; __spec_install_post_strip } } }
31b569b6 423
cc545e1a 424#-----------------------------------------------------------------
425# remove all RPATH from executable binaries and shared object files
426#
427# Requires: find, awk, cut, xargs, chrpath, uname
428#
ee170415
JB
429# Special macros which affect this process
430#%no_install_post_chrpath 1 # disable chrpath at all
431#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
432#
cc545e1a 433%__spec_install_post_chrpath {%{!?debug: \
f67bd19e 434%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
f80cefa3 435if [ -d "$RPM_BUILD_ROOT" ]; then \
559c4907 436 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
65e03cc0 437 if [ -n "$files" ]; then \
0faed11b 438 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
fd3a42b0 439 fi; \
65e03cc0 440 if [ -n "$objs" ]; then \
fefadad0 441 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
65e03cc0
ER
442 echo "$objs" | \
443 while read file; do \
444 rpath= ; \
445 chmod u+w "$file"; \
446 for dir in `chrpath -l "$file" | \
447 awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
448 case $dir in \
449 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
450 echo "remove-rpath: $dir in $file"; \
451 ;; \
452 * ) \
453 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
454 else rpath="$rpath:$dir" ; fi ; \
455 ;; \
456 esac ; \
457 done ; \
458 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
459 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
460 done; \
461 fi; \
f67bd19e 462fi; }; __spec_install_post_chrpath } } }
31b569b6 463
22a54b3e 464#-----------------------------------------------------------------
93b46c00 465# Find and gzip all kernel modules
466#
467# Requires: find
468#
43f81f06 469#%no_install_post_compress_modules 1
93b46c00 470%__spec_install_post_compress_modules { \
f67bd19e 471%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
9cf7c1b9 472 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
9cf7c1b9 473 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
fefadad0
ER
474 if [ "$q" ]; then \
475 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
476 echo "$q" | xargs -r %{__gzip} -9nf; \
477 echo "DONE"; \
478 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
479 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
480 fi; \
31b569b6 481 fi; \
f67bd19e 482}; __spec_install_post_compress_modules } }
cd33aab7 483
e4d71427
ER
484# Remove common Perl files we don't package
485%__spec_install_post_perl_clean {\
486%{!?no_install_post_perl_clean: \
487%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
488} }
489
aad1c8e4 490#-----------------------------------------------------------------
cc6c554c 491# Update GConf2 schemas
aad1c8e4 492#
493# Requires: GConf2
494#
5b8ed3c0 495%gconf_schema_install() \
31b569b6
ER
496 umask 022; \
497 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null \
498 %{nil}
5b8ed3c0 499
500%gconf_schema_uninstall() \
429d047e 501if [ $1 = 0 ]; then \
31b569b6
ER
502 umask 022; \
503 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
429d047e 504fi \
505%{nil}
506
507#-----------------------------------------------------------------
508# Update desktop MIME database
96999189 509# requires: desktop-file-utils
429d047e 510#
9ba5542a 511%update_desktop_database_post() {{ \
429d047e 512 umask 022; \
db1adf13 513 /usr/bin/update-desktop-database -q; \
d8f5dc5b
JB
514}} \
515%{nil}
429d047e 516
38267983 517%update_desktop_database_postun() {{ \
429d047e 518if [ $1 = 0 ]; then \
519 umask 022; \
db1adf13 520 /usr/bin/update-desktop-database -q; \
429d047e 521fi \
d8f5dc5b
JB
522}} \
523%{nil}
429d047e 524
db1adf13 525#-----------------------------------------------------------------
526# Update shared MIME info database
527# requires: shared-mime-info
528#
529%update_mime_database() {{ \
530 umask 022; \
531 /usr/bin/update-mime-database %{_datadir}/mime; \
d8f5dc5b
JB
532}} \
533%{nil}
db1adf13 534
535#-----------------------------------------------------------------
536# Update icon cache
537# requires: gtk+
538#
539%update_icon_cache() {{ \
540 umask 022; \
8ffd1cc2 541 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
d8f5dc5b
JB
542}} \
543%{nil}
db1adf13 544
429d047e 545#-----------------------------------------------------------------
546# Update scrollkeeper database
547# requires: scrollkeeper
548#
549%scrollkeeper_update_post() \
429d047e 550 /usr/bin/scrollkeeper-update -q; \
551 %{nil}
552
553%scrollkeeper_update_postun() \
554if [ $1 = 0 ]; then \
429d047e 555 /usr/bin/scrollkeeper-update -q; \
556fi \
557%{nil}
558
cd33aab7
AM
559#-----------------------------------------------------------------
560# post %install sequence:
561# - autodeps exceptions
562# - compress all man and info pages,
563# - strip all ELF executables and ELF shared objects if not %debug.
5b0f0ac9 564# - compress kernel modules if any
cd33aab7
AM
565
566###################################################################
567# Requires/Provides automation
568# exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
a4852742 569#
fbbdca08
JB
570%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
571%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
572%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
573%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
574%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
a4852742
JB
575#%_noautocompressdoc %{nil}
576#
5b0f0ac9
MM
577%_missing_doc_files_terminate_build 1%{nil}
578%_unpackaged_files_terminate_build %{nil}
4c7d3ba4 579# (X)emacs support
42b7e5ac 580%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
4c7d3ba4
AF
581%_emacs_lispdir %(emacs %___emacs_lispdir_helper)
582%_xemacs_lispdir %(xemacs %___emacs_lispdir_helper)
41a62699 583
984f6de6
JK
584%__php_provides %{nil}
585%__php_requires %{nil}
586%__perl_provides %{nil}
587%__perl_requires %{nil}
63b0a9d7 588%__mono_provides %{nil}
589%__mono_requires %{nil}
41a62699
AF
590
591# Perl specific macro definitions.
23c8318b
ER
592%perl_privlib %(eval "`%{__perl} -V:installprivlib`"; echo $installprivlib)
593%perl_archlib %(eval "`%{__perl} -V:installarchlib`"; echo $installarchlib)
594%perl_vendorlib %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
942c693c 595%perl_vendorarch %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
23c8318b
ER
596%perl_sitelib %(eval "`%{__perl} -V:installsitelib`"; echo $installsitelib)
597%perl_sitearch %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
41a62699 598
cb84f517 599# Ruby
75368847 600%ruby_archdir %(ruby -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)
3da52f86 601%ruby_ridir %(ruby -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)
75368847 602%ruby_rubylibdir %(ruby -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)
a800673f 603%ruby_vendorarchdir %(ruby -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)
604%ruby_vendorlibdir %(ruby -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)
75368847
ER
605%ruby_sitearchdir %(ruby -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)
606%ruby_sitelibdir %(ruby -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)
607%ruby_version %(ruby -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)
5483bb35
ER
608%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
609%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
cb84f517 610
3da52f86 611%php_pear_dir /usr/share/pear
9cf7051f 612%php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)
e140cc62 613%php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)
fddf0dcd 614%php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)
41a62699 615
f73da51b 616# extract php/zend api versions
fddf0dcd
ER
617%php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)
618%php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)
619%php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)
620%php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)
621%zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)
622%zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)
623%zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})
6b2157a6
ER
624
625# helper macro
e255dfdc 626%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
6b2157a6
ER
627
628# macros for public use
629# for php extensions (php-pecl)
ab8d73ee 630%requires_php_extension %{__php_api_requires modules_api php_api_version} \
cc2b296f 631%{__php_api_requires zend_module_api} \
e255dfdc
ER
632%{__php_api_requires -v %php_major_version debug php_debug} \
633%{__php_api_requires -v %php_major_version thread-safety zend_zts}
ab8d73ee 634
6b2157a6
ER
635# for zend extensions
636%requires_zend_extension %{__php_api_requires zend_module_api} \
ab8d73ee 637%{__php_api_requires zend_extension_api} \
e255dfdc
ER
638%{__php_api_requires -v %php_major_version debug php_debug} \
639%{__php_api_requires -v %php_major_version thread-safety zend_zts}
6b2157a6 640
1c107a2d
ER
641# for php pdo modules (php-pecl-PDO_*)
642%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
643
e6ca24e8
ER
644# for using PHP post scripts. for PHP >= 5.0
645%php_webserver_restart \
646[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
febce2c9 647[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
b4080c85
ER
648if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
649 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
650 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
651 %service -q php-fcgi restart \
652 fi \
653fi \
e6ca24e8
ER
654%{nil}
655
656# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
657%php4_webserver_restart \
658[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
febce2c9 659[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
b4080c85
ER
660if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
661 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
662 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
663 %service -q php-fcgi restart \
664 fi \
665fi \
e6ca24e8
ER
666%{nil}
667
b89f672e
AM
668
669# X.org helper macros
04336b74 670%__xorg_abi_requires() Requires: xorg-xserver-server(%{expand:%1}-abi) = %{expand:%{%{!?2:%{1}}%{?2}}}
b89f672e 671#
b444ba80
AM
672%xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
673%xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
674%xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)
675%xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
676%xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
b89f672e
AM
677
678%requires_xorg_xserver_extension %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
679%{__xorg_abi_requires extension xorg_xserver_extension_abi}
680%requires_xorg_xserver_xinput %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
681%{__xorg_abi_requires xinput xorg_xserver_xinput_abi}
682%requires_xorg_xserver_font %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
683%{__xorg_abi_requires font xorg_xserver_font_abi}
684%requires_xorg_xserver_videodrv %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
685%{__xorg_abi_requires videodrv xorg_xserver_videodrv_abi}
686
41a62699
AF
687# Python specific macro definitions.
688# python main version
3da52f86 689%py_ver %(python -c "import sys; print sys.version[:3]")
41a62699
AF
690
691# directories
31b569b6
ER
692%py_prefix %(python -c "import sys; print sys.prefix")
693%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
a4f0b5e0 694%py_scriptdir %{py_prefix}/share/python%{py_ver}
31b569b6 695%py_incdir /usr/include/python%{py_ver}
3da52f86 696%py_sitedir %{py_libdir}/site-packages
a4f0b5e0 697%py_sitescriptdir %{py_scriptdir}/site-packages
31b569b6 698%py_dyndir %{py_libdir}/lib-dynload
41a62699
AF
699
700# pure python modules compilation
31b569b6 701%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
41a62699 702
31b569b6 703%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
41a62699
AF
704
705# Software written in Python language require Python with main version
5177c7b1 706%pyrequires_eq() Requires: %1
41a62699 707
ea4b2900
AF
708# Hardlink binary identical .pyc and .pyo files
709# (idea by glen <at> pld-linux <dot> org)
710%__spec_install_post_py_hardlink {\
f67bd19e 711%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
ea4b2900 712[ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
455bd3f1 713 b="${a%.pyc}.pyo"; \
ea4b2900
AF
714 if cmp -s "$a" "$b"; then \
715 ln -f "$a" "$b"; \
716 fi; \
717done \
f67bd19e 718}; __spec_install_post_py_hardlink } }
ea4b2900 719
16f6f416 720# remove python sources, so that check-files won't complain
ea4b2900
AF
721# (idea by glen <at> pld-linux <dot> org)
722%py_postclean() \
e4e8948b 723for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
9ba5542a 724 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
ea4b2900
AF
725done \
726%{nil}
727
67ed5b97 728# depmod macro
729%depmod() { \
fe30b3ea 730umask 022; \
67ed5b97 731if [ -e /boot/System.map-%1 ]; then \
31b569b6 732 /sbin/depmod -a -F /boot/System.map-%1 %1; \
67ed5b97 733else \
31b569b6
ER
734 if [ -e /boot/System.map ]; then \
735 /sbin/depmod -a -F /boot/System.map %1; \
736 else \
737 /sbin/depmod -a %1; \
738 fi \
67ed5b97 739fi; \
740}
741
495892af 742# XMMS specific macros
31b569b6
ER
743%xmms_prefix %(xmms-config --prefix 2>/dev/null)
744%xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null)
745%xmms_version %(xmms-config --version 2>/dev/null)
746%xmms_datadir %(xmms-config --data-dir 2>/dev/null)
747%xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null)
748%xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null)
749%xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null)
750%xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null)
751%xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null)
752%xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null)
495892af 753
bb128216
PS
754%_target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')
755
e3618ee9 756# user/group checking macros
757#
758# Usage:
759# %userremove myuser
760#
761%userremove /usr/lib/rpm/user_group.sh user del
762%groupremove /usr/lib/rpm/user_group.sh group del
763#
764# Usage:
765# if %usertestrm myuser; then
766# /usr/sbin/userdel -r myuser
767# Note:
768# use these macros only if you need to call userdel/groupdel with
769# a non-standard option or take an extra action; otherwise use the
770# %userremove/%groupremove macros
771#
772%usertestrm /usr/lib/rpm/user_group.sh user testrm
773%grouptestrm /usr/lib/rpm/user_group.sh group testrm
13f70a2c
JK
774# user group membership management macros
775#
776# Usage:
777# %addusertogroup myuser agroup
778#
779%addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
bfd9689c 780
781# banner support (useful in {pre,post}{,un} and triggers)
782#
783# Usage:
a980efc1 784# %banner name [-a] [-e] [-n] [-tn] <<EOF
bfd9689c 785# the banner text, the banner text
a980efc1
ER
786# the banner text, and following line
787#EOF
788# You can use any form of here-document, <<'EOF' <<-EOT will do.
789# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
790#
bfd9689c 791# -a - append to the banner
fb033326 792# -e - send to stderr instead of stdout
1257c400 793# -n - no show banner (overrides -t)
794# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
4055114a
ER
795#
796# Tests:
797# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
798# rpm -E 'date | %banner -e banner' > m; sh -x m
799#
8bea2501 800%banner(aent:) ( \
f1bbc6ff 801RPM_SCRIPTVERBOSITY=5 \
802[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
803if [ -x /usr/bin/banner.sh ]; then \
a980efc1 804 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
f1bbc6ff 805else \
fb033326 806 CMD="cat%{-e: >&2}" \
f1bbc6ff 807fi \
4055114a
ER
808eval $CMD %{?2:%2}%{?3: %3}) \
809%{nil}
1257c400 810
3c972982 811# useradd/groupadd macros
1ebc460a 812# Author: Elan Ruusamäe <glen@pld-linux.org>
29c5556c
ER
813#
814# Usage:
815# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
816# [-g initial_group] [-G group[,...]] login
817#
818# -u uid. REQUIRED
819# -g gid/group. REQUIRED
820# -s defaults to /bin/false
821# -d defaults to /usr/share/empty
822# -c No default
823# -r is accepted but ignored (it's always set)
6eb25d5d 824# -k skeleton dir. defaults to /usr/share/empty
29c5556c
ER
825# rpm specific flags
826# -P package name. defaults to %{name}
827#
29c5556c 828%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
0044d46f
ER
829%{!-u:%{error:useradd: Required argument -u missing}} \
830%{!-g:%{error:useradd: Required argument -g missing}} \
831%{!?1:%{error:useradd: Required parameter login missing}} \
29c5556c
ER
832if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
833 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
834 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
835 exit 1 \
836 fi \
837else \
838 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
839 /usr/sbin/useradd \\\
cc333c8b 840 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
29c5556c
ER
841 -u %{-u*} \\\
842 -r \\\
843 -d %{-d*}%{!-d:/usr/share/empty} \\\
844 -s %{-s*}%{!-s:/bin/false} \\\
85e3e9a1 845 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
29c5556c
ER
846 -g %{-g*} \\\
847 %{-M} \\\
848 %{-G:-G %{-G*}} \\\
6750d9f5 849 %{expand:%{%{#}}} 1>&2 || exit $? \
52e30914 850 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
29c5556c
ER
851fi;
852
29c5556c
ER
853# Usage:
854# %groupadd [-P package] [-g gid] group
855#
856# -g gid. REQUIRED
857#
858# Sample:
859# %groupadd -P %{name}-base -g %{gid} %{name}
860
861%groupadd(g:P:rfo) \
0044d46f
ER
862%{!-g:%{error:groupadd: Required argument -g missing}} \
863%{!?1:%{error:groupadd: Required parameter group missing}} \
29c5556c
ER
864if [ -n "`/usr/bin/getgid %{1}`" ]; then \
865 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
866 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
867 exit 1 \
868 fi \
869else \
870 echo "Adding group %{1} GID=%{-g*}." \
6750d9f5 871 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
52e30914 872 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
29c5556c 873fi;
053b8de1 874
55a50f1a 875# webapp macros
1ebc460a 876# Author: Elan Ruusamäe <glen@pld-linux.org>
ba42a822
ER
877#
878# The config is installed/removed inside trigger, this means that you can any
879# time install apache1/apache/lighttpd package and the configuration file is
43f81f06 880# updated. if you don't need the config for various reason for specific
ba42a822
ER
881# webserver, just remove the symlink from config directory using webapp
882# program. the trigger will not recreate the symlink on upgrades. In other
883# words the config is linked to webserver config directory on first install of
884# PACKAGE or WEBSERVER.
885#
55a50f1a
ER
886# Add package's webserver config to webserver webapps dir.
887# Usage:
217f2cb2 888# %webapp_register WEBSERVER WEBAPP
ba42a822
ER
889#
890%webapp_register() \
891%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
892if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
893 /usr/sbin/webapp register %1 %2\
894fi\
973c1dc7 895# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
afe4f5f0 896if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
5f0b2e29 897 %{expand:%service -q %%1 reload}\
ba42a822
ER
898fi\
899%{nil}
900
901# Remove package's config from webserver webapps dir.
ba42a822 902# Usage:
b9588fe6
ER
903# %webapp_register [-f] WEBSERVER WEBAPP
904%webapp_unregister(f) \
ba42a822
ER
905%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
906# remove link if either of the packages are gone \
afe4f5f0 907if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
217f2cb2 908 /usr/sbin/webapp unregister %1 %2\
5f0b2e29 909 %{expand:%service -q %%1 reload}\
ba42a822
ER
910fi \
911%{nil}
912
8edf8498 913# service macro.
1ebc460a 914# Author: Elan Ruusamäe <glen@pld-linux.org>
8edf8498
ER
915#
916# calls usual service restart on package %post, but skips the restart if
917# administrator has disabled automatic service restarts in either global
918# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
919#
8edf8498 920# Usage:
524e081b 921# %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
8edf8498 922#
dd4e969a 923# -q be silent when service isn't started (for scriplets restaring other package's services)
8edf8498 924#
e42cbd35 925%service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
cec3a041
ER
926
927
91bd3172
ER
928# Java macros. based on jpackage macros.java
929#
930# Root directory where all Java VMs/SDK/JREs are installed.
93406dd9 931%_jvmdir %{_libdir}/jvm
91bd3172
ER
932
933# Root directory where all Java VMs/SDK/JREs expose their jars
93406dd9 934%_jvmjardir %{_libdir}/jvm-exports
91bd3172
ER
935
936# Root directory for all Java VM/SDK/JRE's private things.
937%_jvmprivdir %{_libdir}/jvm-private
938
939# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
93406dd9 940%_jvmlibdir %{_libdir}/jvm
91bd3172
ER
941
942# Root directory for all architecture independent parts of Java VM/SDK/JRE's
943%_jvmdatadir %{_datadir}/jvm
944
945# Root directory for all configurations parts of Java VM/SDK/JRE's
946%_jvmsysconfdir %{_sysconfdir}/jvm
947
948# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
29959405 949%_jvmcommonlibdir %{_libdir}/jvm-common
91bd3172
ER
950
951# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
29959405 952%_jvmcommondatadir %{_datadir}/jvm-common
91bd3172
ER
953
954# Root directory for all common configurations parts of Java VM/SDK/JRE's
29959405 955%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
91bd3172
ER
956
957# Directory where arch-specific (JNI) version-independent jars are installed.
93406dd9 958%_jnidir %{_libdir}/java
91bd3172 959
e7b2fcef 960%java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})
cec3a041 961
43f81f06
ER
962%ant JAVA_HOME=%{java_home} ant
963%jar %{java_home}/bin/jar
e7b2fcef 964%java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)
43f81f06
ER
965%javac %{java_home}/bin/javac
966%javadoc %{java_home}/bin/javadoc
cec3a041 967
43f81f06 968%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
cec3a041
ER
969
970%jpackage_script() \
a2047fce
ER
971install -d $RPM_BUILD_ROOT%{_bindir}\
972cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
cec3a041
ER
973#!/bin/sh\
974#\
975# %{name} script\
976# JPackage Project <http://www.jpackage.org/>\
977\
978# Source functions library\
979. %{_javadir}-utils/java-functions\
980\
981# Source system prefs\
a2047fce 982if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
43f81f06 983 . %{_sysconfdir}/java/%{name}.conf\
cec3a041
ER
984fi\
985\
986# Source user prefs\
a2047fce
ER
987if [ -f $HOME/.%{name}rc ]; then\
988 . $HOME/.%{name}rc\
cec3a041
ER
989fi\
990\
991# Configuration\
992MAIN_CLASS=%1\
993BASE_FLAGS=%2\
994BASE_OPTIONS=%3\
a2047fce 995BASE_JARS="%(echo %4 | tr ':' ' ')"\
cec3a041
ER
996\
997# Set parameters\
998set_jvm\
a2047fce
ER
999set_classpath $BASE_JARS\
1000set_flags $BASE_FLAGS\
1001set_options $BASE_OPTIONS\
cec3a041
ER
1002\
1003# Let's start\
a2047fce 1004run "$@"\
cec3a041
ER
1005EOF
1006
d449d2c8
ER
1007# jpackage 1.7
1008# Directory for maven depmaps
1009#
1010%_mavendepmapdir /etc/maven
1011%_mavendepmapfragdir /etc/maven/fragments
1012
1013#
1014# add_to_depmap adds an entry to the depmap. The arguments are:
1015#
1016# %1 the original groupid
1017# %2 the original artifact id
1018# %3 the version
1019# %4 the new groupid
1020# %5 the new artifactid
1021#
1022
1023%add_to_maven_depmap() \
1024install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1025cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1026<dependency>\
1027 <maven>\
1028 <groupId>%1</groupId>\
1029 <artifactId>%2</artifactId>\
1030 <version>%3</version>\
1031 </maven>\
1032 <jpp>\
1033 <groupId>%4</groupId>\
1034 <artifactId>%5</artifactId>\
1035 <version>%3</version>\
1036 </jpp>\
1037</dependency>\
1038\
1039EOF\
1040%{nil}
1041
1042#==============================================================================
1043#
1044# update_maven_depmap updates the main maven depmap
1045#
1046%update_maven_depmap() \
1047echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1048if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1049cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1050fi\
1051echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1052
1053
e22fc3d1 1054# PEAR install macros
1ebc460a 1055# Author: Elan Ruusamäe <glen@pld-linux.org>
d2a29d34
ER
1056#
1057# Usage:
1058# %%pear_package_setup [-a #] [-n FMT]
1059#
e22fc3d1 1060# -a # - also unpack SOURCE#. for PEAR bootstrapping
d2a29d34 1061# -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
e22fc3d1 1062# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
d2a29d34
ER
1063#
1064# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1065# destination hierarchy. you should copy the tree to buildroot after
1066# patching/reorganizing with %%pear_package_install.
1067#
1068# additionally BUILDROOT is stripped from files and files are converted to UNIX
1069# line endings.
1070#
1071# the pear install process output is recorded to install.log, you should put it
a4f06f46 1072# to %%doc for later debug or just for information.
d2a29d34
ER
1073#
1074# additionally additional-packages.txt is produced if it was detected that the
1075# package has optional dependencies. the file format is suitable of displaying
1076# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1077# automatically added for this file.
e22fc3d1
ER
1078
1079
1080# records install.log and transforms PEAR names to PLD Linux rpm package names.
1081%__pear_install_log \
1082tee install.log \
1083# make post message of optional packages \
1084grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1085if [ -s optional-packages.txt ]; then \
1086 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1087else \
1088 rm -f optional-packages.txt \
1089fi \
1090%{nil}
1091
1092# command invoking pear cli
1093%__pear /usr/bin/pear
1094
856feeea 1095%pear_install(a:n:zD) \
e22fc3d1
ER
1096%__pear \\\
1097 -c pearrc \\\
d2a29d34
ER
1098 -d doc_dir=/docs \\\
1099 -d php_dir=%{php_pear_dir} \\\
1100 -d bin_dir=%{_bindir} \\\
1101 -d data_dir=%{php_pear_dir}/data \\\
1102 -d test_dir=%{php_pear_dir}/tests \\\
1103 install \\\
e22fc3d1 1104 --packagingroot=%{builddir} \\\
d2a29d34
ER
1105 --offline \\\
1106 --nodeps \\\
1107 %{-f:--force} \\\
856feeea
ER
1108 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1109%{nil}
1110
1111# The main macro.
1112# using this macro will append optional-packages.txt to the nocompressdoc list
1113# as it's displayed to user after package install. and adding additional gzip
1114# dep is just waste ;)
1115%pear_package_setup(a:n:zD) \
1116%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1117%define builddir %{_builddir}/%{srcdir} \
1118%setup -q -c -T %{-D:-D} -n %{srcdir} \
1119%{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1120%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1121%pear_install \
e22fc3d1
ER
1122%{-z:cd ..} \
1123cat %{-z:$_N/}.install.log | %__pear_install_log \
1124\
d2a29d34 1125# undos sources \
07fa2259 1126find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
d2a29d34
ER
1127%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1128%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1129%{nil}
1130
0aced28c 1131# Copies exctracted PEAR package structure and PEAR registry to buildroot.
1ebc460a 1132# Author: Elan Ruusamäe <glen@pld-linux.org>
d2a29d34
ER
1133%pear_package_install() \
1134cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1135find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1136# help the developer out a little: \
1137if [ -f _noautoreq ]; then \
1138 echo "AutoReqdep detected:" \
1139 echo "_noautoreq $(cat _noautoreq)" \
1140fi \
1141%{nil}
1142
54294c49
ER
1143
1144# Register OpenLDAP schema.
1ebc460a 1145# Author: Elan Ruusamäe <glen@pld-linux.org>
54294c49
ER
1146#
1147# Usage:
1148# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1149#
1150# -d specify dependant schemas, separated by comma
1151#
1152%openldap_schema_register(d:) \
1153for schema in %*; do \
1154 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1155 %{__sed} -i -e " \
1156 /^include.*local.schema/{ \
1157 iinclude\\t $schema\
1158 } \
1159 " /etc/openldap/slapd.conf \
1160 fi \
1161done \
1162# enable dependant schemas \
1163if [ "%{-d*}" ]; then \
1164 %{__sed} -i -e ' \
1165 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1166 s/^#// \
1167 }' /etc/openldap/slapd.conf \
1168fi \
1169%{nil}
1170
1171# Unregister OpenLDAP schema.
1ebc460a 1172# Author: Elan Ruusamäe <glen@pld-linux.org>
54294c49
ER
1173#
1174# Usage:
1175# %%openldap_schema_unregister %{schemadir}/horde.schema
1176#
1177%openldap_schema_unregister() \
1178for schema in %*; do \
1179 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1180 %{__sed} -i -e " \
1181 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1182 # for symmetry it would be nice if we disable enabled schemas in post, \
1183 # but we really can not do that, it would break something else. \
1184 " /etc/openldap/slapd.conf \
1185 fi \
1186done \
1187%{nil}
1188
feb61fae 1189%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
6ee06092 1190
a4623211 1191
1192# Build modules for kernels 2.6
1193# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1194#
1195# Usage:
650cc681 1196# %build_kernel_modules -m <modules> -C <directory>
a4623211 1197#
1198# remember that proper Makefile is still required
1199# Options:
3c972982 1200# -m <modules> (required) -- comma-separated list of modules to save,
a4623211 1201# without .ko extension, may be placed in subdirectory
650cc681 1202# -C <directory> -- change to <directory> before doing anything
a4623211 1203# -p <arg>, -P <arg> -- arguments passeed to make scripts
bf97e3a6 1204# -c -- do not execute make clean
a4623211 1205# <additional arguments> -- all additional arguments will be passed to
1206# make modules
1207#
1208# Additional patching supported via here document. Try:
1209# %build_kernel_modules -m module <<'EOF'
1210# your patch script here
1211# EOF
1212# Don't use it unless patching depends on config options.
1213
1214# Developer note: don't touch it unless you know how to handle '\'.
1215# - \ in script expands to nothing
1216# - \\\ in script expands to \
8ad8b353 1217# - \\\ inside definition expands to nothing
a4623211 1218# - \\\\\\\ inside definition expands to \
1219# - in last line \ has to touch arguments so arguments passing
1220# in new lines (using \) will be supported
1221
bf97e3a6 1222%build_kernel_modules(p:P:m:C:c) \
a4623211 1223%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1224 \
1225%define Opts \\\\\\\
1226%if "%{_target_base_arch}" != "%{_arch}" \\\
1227 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
4d45063a 1228 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
a4623211 1229 %else \\\
1230 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1231 %endif \\\
1232%else \\\
4d45063a 1233 CC="%{kgcc}" \\\
a4623211 1234%endif \
4d45063a 1235%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
a4623211 1236 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1237 \
8b51c37f 1238%{?-C:cd %{-C*}} \
a4623211 1239compile() { \
1240 L="<"; [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
1241 set -e -x \
d606f9ca 1242 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
a4623211 1243 \
d606f9ca 1244for cfg in ${cfgs:-dist}; do \
a4623211 1245 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1246 \
8e042a98 1247 rm -rf o \
a4623211 1248 install -d o/include/linux \
1249 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1250 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1251 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1252 \
1253 set +x \
1254 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1255 set -x \
1256 \
1257 %if %{with dist_kernel} \
1258 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1259 %{-p*} %{-P*} \\\
1260 %{MakeOpts} \
1261 %else \
1262 install -d o/include/config \
1263 touch o/include/config/MARKER \
1264 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1265 %endif \
1266 \
bf97e3a6 1267 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
a4623211 1268 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
bf97e3a6 1269 M=$PWD %{MakeOpts}} \
a4623211 1270 %{__make} -C %{_kernelsrcdir} modules \\\
1271 ${1+"$@"} \\\
1272 M=$PWD %{MakeOpts} \
1273 \
1274 for MODULE in {%{-m*},}; do \
1275 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1276 done \
1277done \
650cc681 1278%{?-C:cd -} \
a4623211 1279} \
1280compile %{*}\
1281%{nil}
1282
1283
1284# Install kernel modules built by %build_kernel_modules
1285# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1286#
1287# Usage:
1288# %install_kernel_modules -m <modules> -d <directory>
1289#
1290# Options:
3c972982 1291# -m <modules> (required) -- comma-separated list of modules to install,
a4623211 1292# without .ko extension, may be placed in subdirectory
1293# -d <directory> (required) -- in what subdirectory modules should be
1294# installed (eg. misc, kernel/drivers/net)
1295# -s <suffix> -- suffix to use when installing modules, useful when module
1296# with same name exists in kernel already
1297# -n <file> -- name of modprobe config file to use (without .conf extension)
c4bd6177 1298# for defining aliases, only useful with -s
a4623211 1299
1300%install_kernel_modules(m:d:s:n:) \
1301%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1302%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1303%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1304 \
1305%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1306%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
c6bb8dfe 1307 \
d606f9ca 1308local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
a4623211 1309 \
1310for MODULE in {%{-m*},}; do \
1311 [ -n "${MODULE}" ] || continue \
d606f9ca
ER
1312 for cfg in ${cfgs:-dist}; do \
1313 [ "$cfg" = smp ] && suf=smp || suf= \
1314 MNAME=${MODULE##*/} \
1315 install -D ${MODULE}-$cfg.ko \\\
1316 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
b37738c0 1317 %{?-s:install -d %{ModprobeD}$suf \
d606f9ca
ER
1318 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1319 >> %{ModprobeD}$suf/%{-n*}.conf} \
1320 done \
a4623211 1321done \
1322%{nil}
1323
16516cbd 1324# patchset macros
1ebc460a 1325# Author: Elan Ruusamäe <glen@pld-linux.org>
16516cbd
ER
1326#
1327# Usage:
1328# %patchset_source -f <seq(1) format> <start> [<end>]
1329# %patchset_patch <start> [<end>]
1330#
1331# If <end> is omited, it is assumed to be <start>.
1332#
1333# For example in preamble:
1334# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1335# and in %prep:
1336# %patchset_patch 33 44
1337
1338# generate SourceX urls from range START STOP
1339# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1340# The sources start from 10000
cc2d394a 1341%patchset_source(f:b:) %(
8c40a202 1342 base=%{-b*}%{!-b*:10000};
3b7f1777
ER
1343 start=$(expr $base + %1);
1344 end=$(expr $base + %{?2}%{!?2:%{1}});
cc2d394a
ER
1345 # we need to call seq twice as it doesn't allow two formats
1346 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1347 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1348 paste %{tmpdir}/__ps{1,2};
1349 rm -f %{tmpdir}/__ps{1,2};
3b7f1777
ER
1350) \
1351%{nil}
16516cbd
ER
1352
1353# apply sources from %patchset_source
1354# -p specify -pX for %patch line
1355# -b base offset: defaults to 10000
1356%patchset_patch(f:p:b:) %(
8c40a202 1357 base=%{-b*}%{!-b*:10000};
3b7f1777
ER
1358 start=$(expr $base + %1);
1359 end=$(expr $base + %{?2}%{!?2:%{1}});
cc2d394a
ER
1360 echo ": patchset_patch %1%{?2: to %2}";
1361 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
3b7f1777
ER
1362) \
1363%{nil}
16516cbd 1364
c7cb683a 1365# browser plugins v2
1ebc460a 1366# Author: Elan Ruusamäe <glen@pld-linux.org>
c7cb683a
ER
1367#
1368# Usage:
1369# %browser_plugins_add_browser <name> -p <plugindir>
1370#
1371# <name> (required) -- name of the browser. usually %{name}.
1372# -p <plugindir> (required) -- in what directory browser searches for its plugins.
825d0960
ER
1373# -b -- default blacklists
1374# -a <arch> override arch
c7cb683a
ER
1375#
1376# Example:
1377# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1378
1379%_browserpluginsconfdir /etc/browser-plugins
292d3658 1380%_browserpluginsdir %{_libdir}/browser-plugins
c7cb683a
ER
1381%update_browser_plugins /usr/sbin/update-browser-plugins || :
1382
825d0960 1383%browser_plugins_add_browser(p:b:a:) \
2ac4652b 1384 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
c7cb683a 1385 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
825d0960
ER
1386 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1387 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
c7cb683a
ER
1388 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1389 %{-b:cat >> $blacklist_file %{-b*}} \
1390%{nil}
1391
c879189d
ER
1392# Helper for LUA.
1393# split string separated by space into quoted list
1394#
1ebc460a 1395# Author: Elan Ruusamäe <glen@pld-linux.org>
c879189d
ER
1396#
1397# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1398%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1399
1400# adjust /etc/shells by adding and removing shells from there
1ebc460a 1401# Author: Elan Ruusamäe <glen@pld-linux.org>
c879189d
ER
1402#
1403# Usage:
1404# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1405# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1406#
1407# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1408
1409%add_etc_shells(p) %{-p:<lua>}\
1410t = {}\
1411f = io.open("/etc/shells", "r")\
1412if f then\
1413 for l in f:lines() do t[l]=l; end\
1414 f:close()\
1415end\
1416for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1417 if not t[s] then\
b566b93e 1418 print("Adding "..s.." to /etc/shells")\
c879189d
ER
1419 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1420 end\
1421end\
1422%{nil}
1423
1424%remove_etc_shells(p) %{-p:<lua>}\
b566b93e 1425%{-p:if arg[2] == 0 then}\
39e5924d
ER
1426 t = {}\
1427 f = io.open("/etc/shells", "r")\
1428 if f then\
1429 for l in f:lines() do t[l]=l; end\
1430 f:close()\
1431 end\
1432 for _, l in pairs({%{expand:%%__lua_split %*}}) do\
b566b93e 1433 print("Removing "..l.." from /etc/shells")\
39e5924d
ER
1434 t[l] = nil\
1435 end\
1436 s=""\
1437 for _, l in pairs(t) do\
1438 s=s..l.."\\n"\
1439 end\
1440 io.open("/etc/shells", "w"):write(s)\
1441%{-p:end} \
c879189d
ER
1442%{nil}
1443
e22fc3d1 1444# vim:ts=4 sw=4 noet syn=spec
This page took 0.489235 seconds and 4 git commands to generate.